/**
* @module vue-mdc-adapterlist 0.9.2
* @exports VueMDCList
* @copyright (c) 2017-present, Sebastien Tasson
* @license https://opensource.org/licenses/MIT
* @implements {"material-components-web":"^0.29.0"}
* @requires {"vue":"^2.5.6"}
* @see https://github.com/stasson/vue-mdc-adapter
*/
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):t.VueMDCList=e()}(this,function(){"use strict";function t(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window,e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(void 0===f||e){var i=!1;try{t.document.addEventListener("test",null,{get passive(){i=!0}})}catch(t){}f=i}return!!f&&{passive:!0}}var e=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")},i=function(){function t(t,e){for(var i=0;i<e.length;i++){var n=e[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}return function(e,i,n){return i&&t(e.prototype,i),n&&t(e,n),e}}(),n=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var i=arguments[e];for(var n in i)Object.prototype.hasOwnProperty.call(i,n)&&(t[n]=i[n])}return t},a=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function, not "+typeof e);t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}}),e&&(Object.setPrototypeOf?Object.setPrototypeOf(t,e):t.__proto__=e)},r=function(t,e){if(!t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!e||"object"!=typeof e&&"function"!=typeof e?t:e},s={render:function(){var t=this.$createElement;return(this._self._c||t)("ul",{staticClass:"mdc-list",class:this.classes},[this._t("default")],2)},staticRenderFns:[],name:"mdc-list",props:{dense:Boolean,avatarList:Boolean,twoLine:Boolean,bordered:Boolean,interactive:Boolean},provide:function(){return{mdcList:this}},computed:{classes:function(){return{"mdc-list--dense":this.dense,"mdc-list--avatar-list":this.avatarList,"mdc-list--two-line":this.twoLine,"mdc-list--bordered":this.bordered,"mdc-list--non-interactive":!this.interactive}}}},o=function(){function t(){var i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};e(this,t),this.adapter_=i}return i(t,null,[{key:"cssClasses",get:function(){return{}}},{key:"strings",get:function(){return{}}},{key:"numbers",get:function(){return{}}},{key:"defaultAdapter",get:function(){return{}}}]),i(t,[{key:"init",value:function(){}},{key:"destroy",value:function(){}}]),t}(),c=(function(){function t(){e(this,t)}i(t,[{key:"browserSupportsCssVars",value:function(){}},{key:"isUnbounded",value:function(){}},{key:"isSurfaceActive",value:function(){}},{key:"isSurfaceDisabled",value:function(){}},{key:"addClass",value:function(t){}},{key:"removeClass",value:function(t){}},{key:"registerInteractionHandler",value:function(t,e){}},{key:"deregisterInteractionHandler",value:function(t,e){}},{key:"registerDocumentInteractionHandler",value:function(t,e){}},{key:"deregisterDocumentInteractionHandler",value:function(t,e){}},{key:"registerResizeHandler",value:function(t){}},{key:"deregisterResizeHandler",value:function(t){}},{key:"updateCssVariable",value:function(t,e){}},{key:"computeBoundingRect",value:function(){}},{key:"getWindowPageOffset",value:function(){}}])}(),{ROOT:"mdc-ripple-upgraded",UNBOUNDED:"mdc-ripple-upgraded--unbounded",BG_FOCUSED:"mdc-ripple-upgraded--background-focused",FG_ACTIVATION:"mdc-ripple-upgraded--foreground-activation",FG_DEACTIVATION:"mdc-ripple-upgraded--foreground-deactivation"}),d={VAR_LEFT:"--mdc-ripple-left",VAR_TOP:"--mdc-ripple-top",VAR_FG_SIZE:"--mdc-ripple-fg-size",VAR_FG_SCALE:"--mdc-ripple-fg-scale",VAR_FG_TRANSLATE_START:"--mdc-ripple-fg-translate-start",VAR_FG_TRANSLATE_END:"--mdc-ripple-fg-translate-end"},u={PADDING:10,INITIAL_ORIGIN_SCALE:.6,DEACTIVATION_TIMEOUT_MS:225,FG_DEACTIVATION_MS:150,TAP_DELAY_MS:300},l=void 0,f=void 0,v=["touchstart","pointerdown","mousedown","keydown"],_=["touchend","pointerup","mouseup"],p=function(t){function s(t){e(this,s);var i=r(this,(s.__proto__||Object.getPrototypeOf(s)).call(this,n(s.defaultAdapter,t)));return i.layoutFrame_=0,i.frame_={width:0,height:0},i.activationState_=i.defaultActivationState_(),i.xfDuration_=0,i.initialSize_=0,i.maxRadius_=0,i.activateHandler_=function(t){return i.activate_(t)},i.deactivateHandler_=function(t){return i.deactivate_(t)},i.focusHandler_=function(){return requestAnimationFrame(function(){return i.adapter_.addClass(s.cssClasses.BG_FOCUSED)})},i.blurHandler_=function(){return requestAnimationFrame(function(){return i.adapter_.removeClass(s.cssClasses.BG_FOCUSED)})},i.resizeHandler_=function(){return i.layout()},i.unboundedCoords_={left:0,top:0},i.fgScale_=0,i.activationTimer_=0,i.fgDeactivationRemovalTimer_=0,i.activationAnimationHasEnded_=!1,i.activationTimerCallback_=function(){i.activationAnimationHasEnded_=!0,i.runDeactivationUXLogicIfReady_()},i.previousActivationEvent_=null,i}return a(s,o),i(s,null,[{key:"cssClasses",get:function(){return c}},{key:"strings",get:function(){return d}},{key:"numbers",get:function(){return u}},{key:"defaultAdapter",get:function(){return{browserSupportsCssVars:function(){},isUnbounded:function(){},isSurfaceActive:function(){},isSurfaceDisabled:function(){},addClass:function(){},removeClass:function(){},registerInteractionHandler:function(){},deregisterInteractionHandler:function(){},registerDocumentInteractionHandler:function(){},deregisterDocumentInteractionHandler:function(){},registerResizeHandler:function(){},deregisterResizeHandler:function(){},updateCssVariable:function(){},computeBoundingRect:function(){},getWindowPageOffset:function(){}}}}]),i(s,[{key:"isSupported_",value:function(){return this.adapter_.browserSupportsCssVars()}},{key:"defaultActivationState_",value:function(){return{isActivated:!1,hasDeactivationUXRun:!1,wasActivatedByPointer:!1,wasElementMadeActive:!1,activationEvent:null,isProgrammatic:!1}}},{key:"init",value:function(){var t=this;if(this.isSupported_()){this.registerRootHandlers_();var e=s.cssClasses,i=e.ROOT,n=e.UNBOUNDED;requestAnimationFrame(function(){t.adapter_.addClass(i),t.adapter_.isUnbounded()&&t.adapter_.addClass(n),t.layoutInternal_()})}}},{key:"destroy",value:function(){var t=this;if(this.isSupported_()){this.deregisterRootHandlers_(),this.deregisterDeactivationHandlers_();var e=s.cssClasses,i=e.ROOT,n=e.UNBOUNDED;requestAnimationFrame(function(){t.adapter_.removeClass(i),t.adapter_.removeClass(n),t.removeCssVars_()})}}},{key:"registerRootHandlers_",value:function(){var t=this;v.forEach(function(e){t.adapter_.registerInteractionHandler(e,t.activateHandler_)}),this.adapter_.registerInteractionHandler("focus",this.focusHandler_),this.adapter_.registerInteractionHandler("blur",this.blurHandler_),this.adapter_.registerResizeHandler(this.resizeHandler_)}},{key:"registerDeactivationHandlers_",value:function(t){var e=this;"keydown"===t.type?this.adapter_.registerInteractionHandler("keyup",this.deactivateHandler_):_.forEach(function(t){e.adapter_.registerDocumentInteractionHandler(t,e.deactivateHandler_)})}},{key:"deregisterRootHandlers_",value:function(){var t=this;v.forEach(function(e){t.adapter_.deregisterInteractionHandler(e,t.activateHandler_)}),this.adapter_.deregisterInteractionHandler("focus",this.focusHandler_),this.adapter_.deregisterInteractionHandler("blur",this.blurHandler_),this.adapter_.deregisterResizeHandler(this.resizeHandler_)}},{key:"deregisterDeactivationHandlers_",value:function(){var t=this;this.adapter_.deregisterInteractionHandler("keyup",this.deactivateHandler_),_.forEach(function(e){t.adapter_.deregisterDocumentInteractionHandler(e,t.deactivateHandler_)})}},{key:"removeCssVars_",value:function(){var t=this,e=s.strings;Object.keys(e).forEach(function(i){0===i.indexOf("VAR_")&&t.adapter_.updateCssVariable(e[i],null)})}},{key:"activate_",value:function(t){var e=this;if(!this.adapter_.isSurfaceDisabled()){var i=this.activationState_;if(!i.isActivated){var n=this.previousActivationEvent_;n&&t&&n.type!==t.type||(i.isActivated=!0,i.isProgrammatic=null===t,i.activationEvent=t,i.wasActivatedByPointer=!i.isProgrammatic&&("mousedown"===t.type||"touchstart"===t.type||"pointerdown"===t.type),t&&this.registerDeactivationHandlers_(t),requestAnimationFrame(function(){i.wasElementMadeActive=!t||"keydown"!==t.type||e.adapter_.isSurfaceActive(),i.wasElementMadeActive?e.animateActivation_():e.activationState_=e.defaultActivationState_()}))}}}},{key:"activate",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this.activate_(t)}},{key:"animateActivation_",value:function(){var t=this,e=s.strings,i=e.VAR_FG_TRANSLATE_START,n=e.VAR_FG_TRANSLATE_END,a=s.cssClasses,r=a.FG_DEACTIVATION,o=a.FG_ACTIVATION,c=s.numbers.DEACTIVATION_TIMEOUT_MS,d="",u="";if(!this.adapter_.isUnbounded()){var l=this.getFgTranslationCoordinates_(),f=l.startPoint,v=l.endPoint;d=f.x+"px, "+f.y+"px",u=v.x+"px, "+v.y+"px"}this.adapter_.updateCssVariable(i,d),this.adapter_.updateCssVariable(n,u),clearTimeout(this.activationTimer_),clearTimeout(this.fgDeactivationRemovalTimer_),this.rmBoundedActivationClasses_(),this.adapter_.removeClass(r),this.adapter_.computeBoundingRect(),this.adapter_.addClass(o),this.activationTimer_=setTimeout(function(){return t.activationTimerCallback_()},c)}},{key:"getFgTranslationCoordinates_",value:function(){var t=this.activationState_,e=t.activationEvent,i=void 0;return{startPoint:i={x:(i=t.wasActivatedByPointer?function(t,e,i){var n=e.x,a=e.y,r=n+i.left,s=a+i.top,o=void 0,c=void 0;return"touchstart"===t.type?(o=t.changedTouches[0].pageX-r,c=t.changedTouches[0].pageY-s):(o=t.pageX-r,c=t.pageY-s),{x:o,y:c}}(e,this.adapter_.getWindowPageOffset(),this.adapter_.computeBoundingRect()):{x:this.frame_.width/2,y:this.frame_.height/2}).x-this.initialSize_/2,y:i.y-this.initialSize_/2},endPoint:{x:this.frame_.width/2-this.initialSize_/2,y:this.frame_.height/2-this.initialSize_/2}}}},{key:"runDeactivationUXLogicIfReady_",value:function(){var t=this,e=s.cssClasses.FG_DEACTIVATION,i=this.activationState_,n=i.hasDeactivationUXRun,a=i.isActivated;(n||!a)&&this.activationAnimationHasEnded_&&(this.rmBoundedActivationClasses_(),this.adapter_.addClass(e),this.fgDeactivationRemovalTimer_=setTimeout(function(){t.adapter_.removeClass(e)},u.FG_DEACTIVATION_MS))}},{key:"rmBoundedActivationClasses_",value:function(){var t=s.cssClasses.FG_ACTIVATION;this.adapter_.removeClass(t),this.activationAnimationHasEnded_=!1,this.adapter_.computeBoundingRect()}},{key:"resetActivationState_",value:function(){var t=this;this.previousActivationEvent_=this.activationState_.activationEvent,this.activationState_=this.defaultActivationState_(),setTimeout(function(){return t.previousActivationEvent_=null},s.numbers.TAP_DELAY_MS)}},{key:"deactivate_",value:function(t){var e=this,i=this.activationState_;if(i.isActivated){var a=n({},i);if(i.isProgrammatic){requestAnimationFrame(function(){return e.animateDeactivation_(null,a)}),this.resetActivationState_()}else this.deregisterDeactivationHandlers_(),requestAnimationFrame(function(){e.activationState_.hasDeactivationUXRun=!0,e.animateDeactivation_(t,a),e.resetActivationState_()})}}},{key:"deactivate",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this.deactivate_(t)}},{key:"animateDeactivation_",value:function(t,e){var i=e.wasActivatedByPointer,n=e.wasElementMadeActive;(i||n)&&this.runDeactivationUXLogicIfReady_()}},{key:"layout",value:function(){var t=this;this.layoutFrame_&&cancelAnimationFrame(this.layoutFrame_),this.layoutFrame_=requestAnimationFrame(function(){t.layoutInternal_(),t.layoutFrame_=0})}},{key:"layoutInternal_",value:function(){this.frame_=this.adapter_.computeBoundingRect();var t=Math.max(this.frame_.height,this.frame_.width),e=Math.sqrt(Math.pow(this.frame_.width,2)+Math.pow(this.frame_.height,2));this.initialSize_=t*s.numbers.INITIAL_ORIGIN_SCALE,this.maxRadius_=e+s.numbers.PADDING,this.fgScale_=this.maxRadius_/this.initialSize_,this.xfDuration_=1e3*Math.sqrt(this.maxRadius_/1024),this.updateLayoutCssVars_()}},{key:"updateLayoutCssVars_",value:function(){var t=s.strings,e=t.VAR_FG_SIZE,i=t.VAR_LEFT,n=t.VAR_TOP,a=t.VAR_FG_SCALE;this.adapter_.updateCssVariable(e,this.initialSize_+"px"),this.adapter_.updateCssVariable(a,this.fgScale_),this.adapter_.isUnbounded()&&(this.unboundedCoords_={left:Math.round(this.frame_.width/2-this.initialSize_/2),top:Math.round(this.frame_.height/2-this.initialSize_/2)},this.adapter_.updateCssVariable(i,this.unboundedCoords_.left+"px"),this.adapter_.updateCssVariable(n,this.unboundedCoords_.top+"px"))}},{key:"setUnbounded",value:function(t){var e=s.cssClasses.UNBOUNDED;t?this.adapter_.addClass(e):this.adapter_.removeClass(e)}}]),s}(),h=function(s){function o(i,a){return e(this,o),r(this,(o.__proto__||Object.getPrototypeOf(o)).call(this,n({browserSupportsCssVars:function(){return function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if("boolean"==typeof l&&!e)return l;if(t.CSS&&"function"==typeof t.CSS.supports){var i=t.CSS.supports("--css-vars","yes"),n=t.CSS.supports("(--css-vars: yes)")&&t.CSS.supports("color","#00000000");return l=!(!i&&!n||function(t){var e=t.document,i=e.createElement("div");i.className="mdc-ripple-surface--test-edge-var-bug",e.body.appendChild(i);var n=t.getComputedStyle(i),a=null!==n&&"solid"===n.borderTopStyle;return i.remove(),a}(t))}}(window)},isUnbounded:function(){return!1},isSurfaceActive:function(){return i.$el[o.MATCHES](":active")},isSurfaceDisabled:function(){return i.disabled},addClass:function(t){i.$set(i.classes,t,!0)},removeClass:function(t){i.$delete(i.classes,t)},registerInteractionHandler:function(t,e){i.$el.addEventListener(t,e)},deregisterInteractionHandler:function(t,e){i.$el.removeEventListener(t,e)},registerDocumentInteractionHandler:function(e,i){return document.documentElement.addEventListener(e,i,t())},deregisterDocumentInteractionHandler:function(e,i){return document.documentElement.removeEventListener(e,i,t())},registerResizeHandler:function(t){return window.addEventListener("resize",t)},deregisterResizeHandler:function(t){return window.removeEventListener("resize",t)},updateCssVariable:function(t,e){i.$set(i.styles,t,e)},computeBoundingRect:function(){return i.$el.getBoundingClientRect()},getWindowPageOffset:function(){return{x:window.pageXOffset,y:window.pageYOffset}}},a)))}return a(o,p),i(o,null,[{key:"isSurfaceActive",value:function(t){return t[o.MATCHES](":active")}},{key:"MATCHES",get:function(){return o._matches||(o._matches=function(t){return["webkitMatchesSelector","msMatchesSelector","matches"].filter(function(e){return e in t}).pop()}(HTMLElement.prototype))}}]),o}(),m=function(t){return{version:"0.9.2",install:function(e){for(var i in t){var n=t[i];e.component(n.name,n)}},components:t}}({mdcList:s,mdcListItem:{render:function(){var t=this,e=t.$createElement,i=t._self._c||e;return i("li",{staticClass:"mdc-list-item",class:[t.classes,t.itemClasses],style:t.styles,attrs:{tabindex:t.isInteractive?"0":void 0}},[t.hasStartDetail?i("span",{staticClass:"mdc-list-item__graphic"},[t._t("start-detail")],2):t._e(),t._v(" "),t.hasSecondary?i("span",{staticClass:"mdc-list-item__text"},[t._t("default"),t._v(" "),i("span",{staticClass:"mdc-list-item__secondary-text"},[t._t("secondary")],2)],2):t._t("default"),t._v(" "),t.hasEndDetail?i("span",{staticClass:"mdc-list-item__meta"},[t._t("end-detail")],2):t._e()],2)},staticRenderFns:[],name:"mdc-list-item",inject:["mdcList"],props:{selected:Boolean,activated:Boolean},data:function(){return{classes:{},styles:{}}},computed:{itemClasses:function(){return{"mdc-list-item--selected":this.selected,"mdc-list-item--activated":this.activated}},isInteractive:function(){return this.mdcList&&this.mdcList.interactive},hasSecondary:function(){return this.$slots.secondary&&this.mdcList&&this.mdcList.twoLine},hasEndDetail:function(){return!!this.$slots["end-detail"]},hasStartDetail:function(){return!!this.$slots["start-detail"]}},watch:{isInteractive:function(t){t?this.addRipple():this.removeRipple()}},mounted:function(){this.isInteractive&&this.addRipple()},beforeDestroy:function(){this.removeRipple()},methods:{addRipple:function(){if(!this.ripple){var t=new h(this);t.init(),this.ripple=t}},removeRipple:function(){if(this.ripple){var t=this.ripple;this.ripple=null,t.destroy()}}}},mdcListDivider:{render:function(){var t=this.$createElement;return(this._self._c||t)("li",{staticClass:"mdc-list-divider",class:this.classes,attrs:{role:"separator"}})},staticRenderFns:[],name:"mdc-list-divider",props:{inset:Boolean,padded:Boolean},computed:{classes:function(){return{"mdc-list-divider--inset":this.inset,"mdc-list-divider--padded":this.padded}}}},mdcListGroup:{render:function(){var t=this.$createElement;return(this._self._c||t)("div",{staticClass:"mdc-list-group"},[this._t("default")],2)},staticRenderFns:[],name:"mdc-list-group"},mdcListGroupHeader:{render:function(){var t=this.$createElement;return(this._self._c||t)("h3",{staticClass:"mdc-list-group-header mdc-list-group__subheader"},[this._t("default")],2)},staticRenderFns:[],name:"mdc-list-group-header"},mdcListGroupDivider:{render:function(){var t=this.$createElement;return(this._self._c||t)("hr",{staticClass:"mdc-list-group-divider mdc-list-divider"})},staticRenderFns:[],name:"mdc-list-group-divider"}});return function(t){var e=null;"undefined"!=typeof window?e=window.Vue:"undefined"!=typeof global&&(e=global.Vue),e&&e.use(t)}(m),m});
//# sourceMappingURL=list.min.js.map
