/**
* @module vue-mdc-adapterselect 0.9.2
* @exports VueMDCSelect
* @copyright (c) 2017-present, Sebastien Tasson
* @license https://opensource.org/licenses/MIT
* @implements {"material-components-web":"^0.29.0"}
* @requires {"vue":"^2.5.6"}
* @see https://github.com/stasson/vue-mdc-adapter
*/
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):e.VueMDCSelect=t()}(this,function(){"use strict";function e(e,t,n){var i=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=void 0;"function"==typeof CustomEvent?o=new CustomEvent(t,{detail:n,bubbles:i}):(o=document.createEvent("CustomEvent")).initCustomEvent(t,i,!1,n),e.dispatchEvent(o)}function t(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(void 0===v||t){var n="transform"in e.document.createElement("div").style?"transform":"webkitTransform";v=n}return v}var n=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")},i=function(){function e(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}return function(t,n,i){return n&&e(t.prototype,n),i&&e(t,i),t}}(),o=function(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e},r=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var i in n)Object.prototype.hasOwnProperty.call(n,i)&&(e[i]=n[i])}return e},s=function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)},a=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t},u={data:function(){return{hasFocus:!1}},methods:{onMouseDown:function(){this._active=!0},onMouseUp:function(){this._active=!1},onFocusEvent:function(){var e=this;setTimeout(function(){return e.dispatchFocusEvent()},0)},onBlurEvent:function(){var e=this;this._active||setTimeout(function(){return e.dispatchFocusEvent()},0)},dispatchFocusEvent:function(){var e=this.$el===document.activeElement||this.$el.contains(document.activeElement);e!=this.hasFocus&&(this.$emit(e?"focus":"blur"),this.hasFocus=e)}},mounted:function(){this.$el.addEventListener("focusin",this.onFocusEvent),this.$el.addEventListener("focusout",this.onBlurEvent),this.$el.addEventListener("mousedown",this.onMouseDown),this.$el.addEventListener("mouseup",this.onMouseUp)},beforeDestroy:function(){this.$el.removeEventListener("focusin",this.onFocusEvent),this.$el.removeEventListener("focusout",this.onBlurEvent),this.$el.removeEventListener("mousedown",this.onMouseDown),this.$el.removeEventListener("mouseup",this.onMouseUp)}},l={render:function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("select",{directives:[{name:"model",rawName:"v-model",value:e.selected,expression:"selected"}],ref:"root",staticClass:"mdc-select mdc-native-select",attrs:{disabled:e.disabled},on:{change:[function(t){var n=Array.prototype.filter.call(t.target.options,function(e){return e.selected}).map(function(e){return"_value"in e?e._value:e.value});e.selected=t.target.multiple?n:n[0]},e.onChange]}},[e.label?n("option",{attrs:{disabled:"disabled",value:""}},[e._v(e._s(e.label))]):e._e(),e._v(" "),e._t("default")],2)},staticRenderFns:[],name:"mdc-native-select",model:{prop:"value",event:"change"},props:{value:[String,Array],disabled:Boolean,label:String},data:function(){return{selected:this.value}},methods:{onChange:function(){this.$emit("change",this.selected)}}},c=function(){function e(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};n(this,e),this.adapter_=t}return i(e,null,[{key:"cssClasses",get:function(){return{}}},{key:"strings",get:function(){return{}}},{key:"numbers",get:function(){return{}}},{key:"defaultAdapter",get:function(){return{}}}]),i(e,[{key:"init",value:function(){}},{key:"destroy",value:function(){}}]),e}(),d=(function(){function e(){n(this,e)}i(e,[{key:"addClass",value:function(e){}},{key:"removeClass",value:function(e){}},{key:"hasClass",value:function(e){}},{key:"hasNecessaryDom",value:function(){}},{key:"getAttributeForEventTarget",value:function(e,t){}},{key:"eventTargetHasClass",value:function(e,t){}},{key:"getInnerDimensions",value:function(){}},{key:"hasAnchor",value:function(){}},{key:"getAnchorDimensions",value:function(){}},{key:"getWindowDimensions",value:function(){}},{key:"getNumberOfItems",value:function(){}},{key:"registerInteractionHandler",value:function(e,t){}},{key:"deregisterInteractionHandler",value:function(e,t){}},{key:"registerBodyClickHandler",value:function(e){}},{key:"deregisterBodyClickHandler",value:function(e){}},{key:"getIndexForEventTarget",value:function(e){}},{key:"notifySelected",value:function(e){}},{key:"notifyCancel",value:function(){}},{key:"saveFocus",value:function(){}},{key:"restoreFocus",value:function(){}},{key:"isFocused",value:function(){}},{key:"focus",value:function(){}},{key:"getFocusedItemIndex",value:function(){}},{key:"focusItemAtIndex",value:function(e){}},{key:"isRtl",value:function(){}},{key:"setTransformOrigin",value:function(e){}},{key:"setPosition",value:function(e){}},{key:"setMaxHeight",value:function(e){}}])}(),{ROOT:"mdc-simple-menu",OPEN:"mdc-simple-menu--open",ANIMATING_OPEN:"mdc-simple-menu--animating-open",ANIMATING_CLOSED:"mdc-simple-menu--animating-closed",LIST_ITEM:"mdc-list-item"}),f={ITEMS_SELECTOR:".mdc-simple-menu__items",SELECTED_EVENT:"MDCSimpleMenu:selected",CANCEL_EVENT:"MDCSimpleMenu:cancel",ARIA_DISABLED_ATTR:"aria-disabled"},h={SELECTED_TRIGGER_DELAY:50,TRANSITION_OPEN_DURATION:120,TRANSITION_CLOSE_DURATION:75,MARGIN_TO_EDGE:32,ANCHOR_TO_MENU_WIDTH_RATIO:.67,OFFSET_TO_MENU_HEIGHT_RATIO:.1},m={BOTTOM:1,CENTER:2,RIGHT:4,FLIP_RTL:8},_={TOP_LEFT:0,TOP_RIGHT:m.RIGHT,BOTTOM_LEFT:m.BOTTOM,BOTTOM_RIGHT:m.BOTTOM|m.RIGHT,TOP_START:m.FLIP_RTL,TOP_END:m.FLIP_RTL|m.RIGHT,BOTTOM_START:m.BOTTOM|m.FLIP_RTL,BOTTOM_END:m.BOTTOM|m.RIGHT|m.FLIP_RTL},p=function(e){function t(e){n(this,t);var i=a(this,(t.__proto__||Object.getPrototypeOf(t)).call(this,r(t.defaultAdapter,e)));return i.clickHandler_=function(e){return i.handlePossibleSelected_(e)},i.keydownHandler_=function(e){return i.handleKeyboardDown_(e)},i.keyupHandler_=function(e){return i.handleKeyboardUp_(e)},i.documentClickHandler_=function(e){return i.handleDocumentClick_(e)},i.isOpen_=!1,i.openAnimationEndTimerId_=0,i.closeAnimationEndTimerId_=0,i.selectedTriggerTimerId_=0,i.animationRequestId_=0,i.dimensions_,i.itemHeight_,i.anchorCorner_=_.TOP_START,i.anchorMargin_={top:0,right:0,bottom:0,left:0},i.measures_=null,i}return s(t,c),i(t,null,[{key:"cssClasses",get:function(){return d}},{key:"strings",get:function(){return f}},{key:"numbers",get:function(){return h}},{key:"Corner",get:function(){return _}},{key:"defaultAdapter",get:function(){return{addClass:function(){},removeClass:function(){},hasClass:function(){return!1},hasNecessaryDom:function(){return!1},getAttributeForEventTarget:function(){},eventTargetHasClass:function(){},getInnerDimensions:function(){return{}},hasAnchor:function(){return!1},getAnchorDimensions:function(){return{}},getWindowDimensions:function(){return{}},getNumberOfItems:function(){return 0},registerInteractionHandler:function(){},deregisterInteractionHandler:function(){},registerBodyClickHandler:function(){},deregisterBodyClickHandler:function(){},getIndexForEventTarget:function(){return 0},notifySelected:function(){},notifyCancel:function(){},saveFocus:function(){},restoreFocus:function(){},isFocused:function(){return!1},focus:function(){},getFocusedItemIndex:function(){return-1},focusItemAtIndex:function(){},isRtl:function(){return!1},setTransformOrigin:function(){},setPosition:function(){},setMaxHeight:function(){}}}}]),i(t,[{key:"init",value:function(){var e=t.cssClasses,n=e.ROOT,i=e.OPEN;if(!this.adapter_.hasClass(n))throw new Error(n+" class required in root element.");if(!this.adapter_.hasNecessaryDom())throw new Error("Required DOM nodes missing in "+n+" component.");this.adapter_.hasClass(i)&&(this.isOpen_=!0),this.adapter_.registerInteractionHandler("click",this.clickHandler_),this.adapter_.registerInteractionHandler("keyup",this.keyupHandler_),this.adapter_.registerInteractionHandler("keydown",this.keydownHandler_)}},{key:"destroy",value:function(){clearTimeout(this.selectedTriggerTimerId_),clearTimeout(this.openAnimationEndTimerId_),clearTimeout(this.closeAnimationEndTimerId_),cancelAnimationFrame(this.animationRequestId_),this.adapter_.deregisterInteractionHandler("click",this.clickHandler_),this.adapter_.deregisterInteractionHandler("keyup",this.keyupHandler_),this.adapter_.deregisterInteractionHandler("keydown",this.keydownHandler_),this.adapter_.deregisterBodyClickHandler(this.documentClickHandler_)}},{key:"setAnchorCorner",value:function(e){this.anchorCorner_=e}},{key:"setAnchorMargin",value:function(e){this.anchorMargin_.top="number"==typeof e.top?e.top:0,this.anchorMargin_.right="number"==typeof e.right?e.right:0,this.anchorMargin_.bottom="number"==typeof e.bottom?e.bottom:0,this.anchorMargin_.left="number"==typeof e.left?e.left:0}},{key:"focusOnOpen_",value:function(e){null===e?(this.adapter_.focus(),this.adapter_.isFocused()||this.adapter_.focusItemAtIndex(0)):this.adapter_.focusItemAtIndex(e)}},{key:"handleDocumentClick_",value:function(e){for(var t=e.target;t&&t!==document.documentElement;){if(this.adapter_.eventTargetHasClass(t,d.LIST_ITEM))return;t=t.parentNode}this.adapter_.notifyCancel(),this.close(e)}},{key:"handleKeyboardDown_",value:function(e){if(e.altKey||e.ctrlKey||e.metaKey)return!0;var t=e.keyCode,n=e.key,i=e.shiftKey,o="Tab"===n||9===t,r="ArrowUp"===n||38===t,s="ArrowDown"===n||40===t,a="Space"===n||32===t,u=this.adapter_.getFocusedItemIndex(),l=this.adapter_.getNumberOfItems()-1;return i&&o&&0===u?(this.adapter_.focusItemAtIndex(l),e.preventDefault(),!1):!i&&o&&u===l?(this.adapter_.focusItemAtIndex(0),e.preventDefault(),!1):((r||s||a)&&e.preventDefault(),r?0===u||this.adapter_.isFocused()?this.adapter_.focusItemAtIndex(l):this.adapter_.focusItemAtIndex(u-1):s&&(u===l||this.adapter_.isFocused()?this.adapter_.focusItemAtIndex(0):this.adapter_.focusItemAtIndex(u+1)),!0)}},{key:"handleKeyboardUp_",value:function(e){if(e.altKey||e.ctrlKey||e.metaKey)return!0;var t=e.keyCode,n=e.key,i="Escape"===n||27===t;return("Enter"===n||13===t||("Space"===n||32===t))&&this.handlePossibleSelected_(e),i&&(this.adapter_.notifyCancel(),this.close()),!0}},{key:"handlePossibleSelected_",value:function(e){var t=this;if("true"!==this.adapter_.getAttributeForEventTarget(e.target,f.ARIA_DISABLED_ATTR)){var n=this.adapter_.getIndexForEventTarget(e.target);n<0||this.selectedTriggerTimerId_||(this.selectedTriggerTimerId_=setTimeout(function(){t.selectedTriggerTimerId_=0,t.close(),t.adapter_.notifySelected({index:n})},h.SELECTED_TRIGGER_DELAY))}}},{key:"getAutoLayoutMeasurements_",value:function(){var e=this.adapter_.getAnchorDimensions(),t=this.adapter_.getWindowDimensions();return{viewport:t,viewportDistance:{top:e.top,right:t.width-e.right,left:e.left,bottom:t.height-e.bottom},anchorHeight:e.height,anchorWidth:e.width,menuHeight:this.dimensions_.height,menuWidth:this.dimensions_.width}}},{key:"getOriginCorner_",value:function(){var e=_.TOP_LEFT,t=this.measures_,n=t.viewportDistance,i=t.anchorHeight,o=t.anchorWidth,r=t.menuHeight,s=t.menuWidth,a=Boolean(this.anchorCorner_&m.BOTTOM),u=a?n.top+i+this.anchorMargin_.bottom:n.top+this.anchorMargin_.top,l=r-(a?n.bottom-this.anchorMargin_.bottom:n.bottom+i-this.anchorMargin_.top);l>0&&r-u<l&&(e|=m.BOTTOM);var c=this.adapter_.isRtl(),d=Boolean(this.anchorCorner_&m.FLIP_RTL),f=Boolean(this.anchorCorner_&m.RIGHT),h=f&&!c||!f&&d&&c,p=s-(h?n.left+o+this.anchorMargin_.right:n.left+this.anchorMargin_.left),v=s-(h?n.right-this.anchorMargin_.right:n.right+o-this.anchorMargin_.left);return(p<0&&h&&c||f&&!h&&p<0||v>0&&p<v)&&(e|=m.RIGHT),e}},{key:"getHorizontalOriginOffset_",value:function(e){var t=this.measures_.anchorWidth,n=Boolean(e&m.RIGHT),i=Boolean(this.anchorCorner_&m.RIGHT),o=0;if(n){o=i?t-this.anchorMargin_.left:this.anchorMargin_.right}else{o=i?t-this.anchorMargin_.right:this.anchorMargin_.left}return o}},{key:"getVerticalOriginOffset_",value:function(e){var n=this.measures_,i=n.viewport,o=n.viewportDistance,r=n.anchorHeight,s=n.menuHeight,a=Boolean(e&m.BOTTOM),u=t.numbers.MARGIN_TO_EDGE,l=Boolean(this.anchorCorner_&m.BOTTOM),c=!l,d=0;return a?(d=l?r-this.anchorMargin_.top:-this.anchorMargin_.bottom,c&&s>o.top+r&&(d=-(Math.min(s,i.height-u)-(o.top+r)))):(d=l?r+this.anchorMargin_.bottom:this.anchorMargin_.top,c&&s>o.bottom+r&&(d=-(Math.min(s,i.height-u)-(o.bottom+r)))),d}},{key:"getMenuMaxHeight_",value:function(e){var t=0,n=this.measures_.viewportDistance,i=Boolean(e&m.BOTTOM);return this.anchorCorner_&m.BOTTOM&&(t=i?n.top+this.anchorMargin_.top:n.bottom-this.anchorMargin_.bottom),t}},{key:"autoPosition_",value:function(){var e;if(this.adapter_.hasAnchor()){this.measures_=this.getAutoLayoutMeasurements_();var t=this.getOriginCorner_(),n=this.getMenuMaxHeight_(t),i=t&m.BOTTOM?"bottom":"top",r=t&m.RIGHT?"right":"left",s=this.getHorizontalOriginOffset_(t),a=this.getVerticalOriginOffset_(t),u=(e={},o(e,r,s?s+"px":"0"),o(e,i,a?a+"px":"0"),e),l=this.measures_,c=l.anchorWidth,d=l.menuHeight;if(c/l.menuWidth>h.ANCHOR_TO_MENU_WIDTH_RATIO&&(r="center"),!(this.anchorCorner_&m.BOTTOM)&&Math.abs(a/d)>h.OFFSET_TO_MENU_HEIGHT_RATIO){var f=100*Math.abs(a/d),_=t&m.BOTTOM?100-f:f;i=Math.round(100*_)/100+"%"}this.adapter_.setTransformOrigin(r+" "+i),this.adapter_.setPosition(u),this.adapter_.setMaxHeight(n?n+"px":""),this.measures_=null}}},{key:"open",value:function(){var e=this,n=(arguments.length>0&&void 0!==arguments[0]?arguments[0]:{}).focusIndex,i=void 0===n?null:n;this.adapter_.saveFocus(),this.adapter_.addClass(t.cssClasses.ANIMATING_OPEN),this.animationRequestId_=requestAnimationFrame(function(){e.dimensions_=e.adapter_.getInnerDimensions(),e.autoPosition_(),e.adapter_.addClass(t.cssClasses.OPEN),e.focusOnOpen_(i),e.adapter_.registerBodyClickHandler(e.documentClickHandler_),e.openAnimationEndTimerId_=setTimeout(function(){e.openAnimationEndTimerId_=0,e.adapter_.removeClass(t.cssClasses.ANIMATING_OPEN)},h.TRANSITION_OPEN_DURATION)}),this.isOpen_=!0}},{key:"close",value:function(){var e=this,n=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;!!n&&"true"===this.adapter_.getAttributeForEventTarget(n.target,f.ARIA_DISABLED_ATTR)||(this.adapter_.deregisterBodyClickHandler(this.documentClickHandler_),this.adapter_.addClass(t.cssClasses.ANIMATING_CLOSED),requestAnimationFrame(function(){e.adapter_.removeClass(t.cssClasses.OPEN),e.closeAnimationEndTimerId_=setTimeout(function(){e.closeAnimationEndTimerId_=0,e.adapter_.removeClass(t.cssClasses.ANIMATING_CLOSED)},h.TRANSITION_CLOSE_DURATION)}),this.isOpen_=!1,this.adapter_.restoreFocus())}},{key:"isOpen",value:function(){return this.isOpen_}}]),t}(),v=void 0,g={render:function(){var e=this.$createElement,t=this._self._c||e;return t("div",{ref:"root",staticClass:"mdc-menu mdc-simple-menu",class:this.classes,style:this.styles,attrs:{tabindex:"-1"}},[t("ul",{ref:"items",staticClass:"mdc-simple-menu__items mdc-list",attrs:{role:"menu","aria-hidden":"true"}},[this._t("default")],2)])},staticRenderFns:[],name:"mdc-menu",props:{"open-from-top-left":Boolean,"open-from-top-right":Boolean,"open-from-bottom-left":Boolean,"open-from-bottom-right":Boolean},data:function(){return{classes:{"mdc-simple-menu--open-from-top-left":this.openFromTopLeft,"mdc-simple-menu--open-from-top-right":this.openFromTopRight,"mdc-simple-menu--open-from-bottom-left":this.openFromBottomLeft,"mdc-simple-menu--open-from-bottom-right":this.openFromBottomRight},styles:{},items:[]}},methods:{show:function(e){this.foundation.open(e)},hide:function(){this.foundation.close()},isOpen:function(){return!!this.foundation&&this.foundation.isOpen()}},mounted:function(){var n=this,i=function(){n.items=[].slice.call(n.$refs.items.querySelectorAll(".mdc-list-item[role]")),n.$emit("update")};this.slotObserver=new MutationObserver(function(){return i()}),this.slotObserver.observe(this.$el,{childList:!0,subtree:!0}),this._previousFocus=void 0,this.foundation=new p({addClass:function(e){return n.$set(n.classes,e,!0)},removeClass:function(e){return n.$delete(n.classes,e)},hasClass:function(e){return n.$refs.root.classList.contains(e)},hasNecessaryDom:function(){return Boolean(n.$refs.items)},getAttributeForEventTarget:function(e,t){return e.getAttribute(t)},eventTargetHasClass:function(e,t){return e.classList.contains(t)},getInnerDimensions:function(){return{width:n.$refs.items.offsetWidth,height:n.$refs.items.offsetHeight}},hasAnchor:function(){return n.$refs.root.parentElement&&n.$refs.root.parentElement.classList.contains("mdc-menu-anchor")},getAnchorDimensions:function(){return n.$refs.root.parentElement.getBoundingClientRect()},getWindowDimensions:function(){return{width:window.innerWidth,height:window.innerHeight}},getNumberOfItems:function(){return n.items.length},registerInteractionHandler:function(e,t){return n.$refs.root.addEventListener(e,t)},deregisterInteractionHandler:function(e,t){return n.$refs.root.removeEventListener(e,t)},registerBodyClickHandler:function(e){return document.body.addEventListener("click",e)},deregisterBodyClickHandler:function(e){return document.body.removeEventListener("click",e)},getIndexForEventTarget:function(e){return n.items.indexOf(e)},notifySelected:function(t){var i={index:t.index,item:n.items[t.index]};n.$emit("select",i),e(n.$el,p.strings.SELECTED_EVENT,i)},notifyCancel:function(){n.$emit("cancel"),e(n.$el,p.strings.CANCEL_EVENT,{})},saveFocus:function(){n._previousFocus=document.activeElement},restoreFocus:function(){n._previousFocus&&n._previousFocus.focus()},isFocused:function(){return document.activeElement===n.$refs.root},focus:function(){return n.$refs.root.focus()},getFocusedItemIndex:function(){return n.items.indexOf(document.activeElement)},focusItemAtIndex:function(e){return n.items[e].focus()},isRtl:function(){return"rtl"===getComputedStyle(n.$refs.root).getPropertyValue("direction")},setTransformOrigin:function(e){n.$set(n.styles,t(window)+"-origin",e)},setPosition:function(e){n.$set(n.styles,"left",e.left),n.$set(n.styles,"right",e.right),n.$set(n.styles,"top",e.top),n.$set(n.styles,"bottom",e.bottom)},setMaxHeight:function(e){n.$set(n.styles,"max-height",e)}}),i(),this.foundation.init()},beforeDestroy:function(){this._previousFocus=null,this.slotObserver.disconnect(),this.foundation.destroy()}},y=function(){function e(t){var i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:void 0;n(this,e),this.root_=t;for(var o=arguments.length,r=Array(o>2?o-2:0),s=2;s<o;s++)r[s-2]=arguments[s];this.initialize.apply(this,r),this.foundation_=void 0===i?this.getDefaultFoundation():i,this.foundation_.init(),this.initialSyncWithDOM()}return i(e,null,[{key:"attachTo",value:function(t){return new e(t,new c)}}]),i(e,[{key:"initialize",value:function(){}},{key:"getDefaultFoundation",value:function(){throw new Error("Subclasses must override getDefaultFoundation to return a properly configured foundation class")}},{key:"initialSyncWithDOM",value:function(){}},{key:"destroy",value:function(){this.foundation_.destroy()}},{key:"listen",value:function(e,t){this.root_.addEventListener(e,t)}},{key:"unlisten",value:function(e,t){this.root_.removeEventListener(e,t)}},{key:"emit",value:function(e,t){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],i=void 0;"function"==typeof CustomEvent?i=new CustomEvent(e,{detail:t,bubbles:n}):(i=document.createEvent("CustomEvent")).initCustomEvent(e,n,!1,t),this.root_.dispatchEvent(i)}}]),e}(),b={BOTTOM_LINE:"mdc-select__bottom-line",BOTTOM_LINE_ACTIVE:"mdc-select__bottom-line--active",BOX:"mdc-select--box",DISABLED:"mdc-select--disabled",LABEL_FLOAT_ABOVE:"mdc-select__label--float-above",OPEN:"mdc-select--open",ROOT:"mdc-select",SCROLL_LOCK:"mdc-select-scroll-lock"},T={CHANGE_EVENT:"MDCSelect:change",BOTTOM_LINE_SELECTOR:".mdc-select__bottom-line",LABEL_SELECTOR:".mdc-select__label",MENU_SELECTOR:".mdc-select__menu",SURFACE_SELECTOR:".mdc-select__surface",SELECTED_TEXT_SELECTOR:".mdc-select__selected-text"},E=(function(e){function o(){var e;n(this,o);for(var t=arguments.length,i=Array(t),r=0;r<t;r++)i[r]=arguments[r];var s=a(this,(e=o.__proto__||Object.getPrototypeOf(o)).call.apply(e,[this].concat(i)));return s.previousFocus_,s}s(o,y),i(o,[{key:"show",value:function(){var e=(arguments.length>0&&void 0!==arguments[0]?arguments[0]:{}).focusIndex,t=void 0===e?null:e;this.foundation_.open({focusIndex:t})}},{key:"hide",value:function(){this.foundation_.close()}},{key:"setAnchorCorner",value:function(e){this.foundation_.setAnchorCorner(e)}},{key:"setAnchorMargin",value:function(e){this.foundation_.setAnchorMargin(e)}},{key:"getDefaultFoundation",value:function(){var e=this;return new p({addClass:function(t){return e.root_.classList.add(t)},removeClass:function(t){return e.root_.classList.remove(t)},hasClass:function(t){return e.root_.classList.contains(t)},hasNecessaryDom:function(){return Boolean(e.itemsContainer_)},getAttributeForEventTarget:function(e,t){return e.getAttribute(t)},eventTargetHasClass:function(e,t){return e.classList.contains(t)},getInnerDimensions:function(){var t=e.itemsContainer_;return{width:t.offsetWidth,height:t.offsetHeight}},hasAnchor:function(){return e.root_.parentElement&&e.root_.parentElement.classList.contains("mdc-menu-anchor")},getAnchorDimensions:function(){return e.root_.parentElement.getBoundingClientRect()},getWindowDimensions:function(){return{width:window.innerWidth,height:window.innerHeight}},getNumberOfItems:function(){return e.items.length},registerInteractionHandler:function(t,n){return e.root_.addEventListener(t,n)},deregisterInteractionHandler:function(t,n){return e.root_.removeEventListener(t,n)},registerBodyClickHandler:function(e){return document.body.addEventListener("click",e)},deregisterBodyClickHandler:function(e){return document.body.removeEventListener("click",e)},getIndexForEventTarget:function(t){return e.items.indexOf(t)},notifySelected:function(t){return e.emit(p.strings.SELECTED_EVENT,{index:t.index,item:e.items[t.index]})},notifyCancel:function(){return e.emit(p.strings.CANCEL_EVENT,{})},saveFocus:function(){e.previousFocus_=document.activeElement},restoreFocus:function(){e.previousFocus_&&e.previousFocus_.focus()},isFocused:function(){return document.activeElement===e.root_},focus:function(){return e.root_.focus()},getFocusedItemIndex:function(){return e.items.indexOf(document.activeElement)},focusItemAtIndex:function(t){return e.items[t].focus()},isRtl:function(){return"rtl"===getComputedStyle(e.root_).getPropertyValue("direction")},setTransformOrigin:function(n){e.root_.style[t(window)+"-origin"]=n},setPosition:function(t){e.root_.style.left="left"in t?t.left:null,e.root_.style.right="right"in t?t.right:null,e.root_.style.top="top"in t?t.top:null,e.root_.style.bottom="bottom"in t?t.bottom:null},setMaxHeight:function(t){e.root_.style.maxHeight=t}})}},{key:"open",get:function(){return this.foundation_.isOpen()},set:function(e){e?this.foundation_.open():this.foundation_.close()}},{key:"itemsContainer_",get:function(){return this.root_.querySelector(p.strings.ITEMS_SELECTOR)}},{key:"items",get:function(){var e=this.itemsContainer_;return[].slice.call(e.querySelectorAll(".mdc-list-item[role]"))}}],[{key:"attachTo",value:function(e){return new o(e)}}])}(),[{key:"ArrowUp",keyCode:38,forType:"keydown"},{key:"ArrowDown",keyCode:40,forType:"keydown"},{key:"Space",keyCode:32,forType:"keyup"}]),C=function(e){function t(e){n(this,t);var i=a(this,(t.__proto__||Object.getPrototypeOf(t)).call(this,r(t.defaultAdapter,e)));return i.ctx_=null,i.selectedIndex_=-1,i.disabled_=!1,i.isFocused_=!1,i.animationRequestId_=0,i.displayHandler_=function(e){e.preventDefault(),i.adapter_.isMenuOpen()||i.open_()},i.displayViaKeyboardHandler_=function(e){return i.handleDisplayViaKeyboard_(e)},i.selectionHandler_=function(e){var t=e.detail.index;t!==i.selectedIndex_&&(i.setSelectedIndex(t),i.adapter_.notifyChange()),i.close_()},i.cancelHandler_=function(){i.close_(),-1===i.selectedIndex_&&i.adapter_.removeClassFromLabel(b.LABEL_FLOAT_ABOVE)},i}return s(t,c),i(t,null,[{key:"cssClasses",get:function(){return b}},{key:"strings",get:function(){return T}},{key:"defaultAdapter",get:function(){return{addClass:function(){},removeClass:function(){},addClassToLabel:function(){},removeClassFromLabel:function(){},addClassToBottomLine:function(){},removeClassFromBottomLine:function(){},setBottomLineAttr:function(){},addBodyClass:function(){},removeBodyClass:function(){},setAttr:function(){},rmAttr:function(){},computeBoundingRect:function(){return{left:0,top:0}},registerInteractionHandler:function(){},deregisterInteractionHandler:function(){},focus:function(){},makeTabbable:function(){},makeUntabbable:function(){},getComputedStyleValue:function(){return""},setStyle:function(){},create2dRenderingContext:function(){return{font:"",measureText:function(){return{width:0}}}},setMenuElStyle:function(){},setMenuElAttr:function(){},rmMenuElAttr:function(){},getMenuElOffsetHeight:function(){return 0},openMenu:function(){},isMenuOpen:function(){return!1},setSelectedTextContent:function(){},getNumberOfOptions:function(){return 0},getTextForOptionAtIndex:function(){return""},getValueForOptionAtIndex:function(){return""},setAttrForOptionAtIndex:function(){},rmAttrForOptionAtIndex:function(){},getOffsetTopForOptionAtIndex:function(){return 0},registerMenuInteractionHandler:function(){},deregisterMenuInteractionHandler:function(){},notifyChange:function(){},getWindowInnerHeight:function(){return 0}}}}]),i(t,[{key:"init",value:function(){this.ctx_=this.adapter_.create2dRenderingContext(),this.adapter_.registerInteractionHandler("click",this.displayHandler_),this.adapter_.registerInteractionHandler("keydown",this.displayViaKeyboardHandler_),this.adapter_.registerInteractionHandler("keyup",this.displayViaKeyboardHandler_),this.adapter_.registerMenuInteractionHandler(p.strings.SELECTED_EVENT,this.selectionHandler_),this.adapter_.registerMenuInteractionHandler(p.strings.CANCEL_EVENT,this.cancelHandler_),this.resize()}},{key:"destroy",value:function(){this.ctx_=null,cancelAnimationFrame(this.animationRequestId_),this.adapter_.deregisterInteractionHandler("click",this.displayHandler_),this.adapter_.deregisterInteractionHandler("keydown",this.displayViaKeyboardHandler_),this.adapter_.deregisterInteractionHandler("keyup",this.displayViaKeyboardHandler_),this.adapter_.deregisterMenuInteractionHandler(p.strings.SELECTED_EVENT,this.selectionHandler_),this.adapter_.deregisterMenuInteractionHandler(p.strings.CANCEL_EVENT,this.cancelHandler_)}},{key:"getValue",value:function(){return this.selectedIndex_>=0?this.adapter_.getValueForOptionAtIndex(this.selectedIndex_):""}},{key:"getSelectedIndex",value:function(){return this.selectedIndex_}},{key:"setSelectedIndex",value:function(e){this.selectedIndex_>=0&&this.adapter_.rmAttrForOptionAtIndex(this.selectedIndex_,"aria-selected"),this.selectedIndex_=e>=0&&e<this.adapter_.getNumberOfOptions()?e:-1;var t="";this.selectedIndex_>=0&&(t=this.adapter_.getTextForOptionAtIndex(this.selectedIndex_).trim(),this.adapter_.setAttrForOptionAtIndex(this.selectedIndex_,"aria-selected","true")),this.adapter_.setSelectedTextContent(t)}},{key:"isDisabled",value:function(){return this.disabled_}},{key:"setDisabled",value:function(e){var n=t.cssClasses.DISABLED;this.disabled_=e,this.disabled_?(this.adapter_.addClass(n),this.adapter_.setAttr("aria-disabled","true"),this.adapter_.makeUntabbable()):(this.adapter_.removeClass(n),this.adapter_.rmAttr("aria-disabled"),this.adapter_.makeTabbable())}},{key:"resize",value:function(){var e=this.adapter_.getComputedStyleValue("font"),t=parseFloat(this.adapter_.getComputedStyleValue("letter-spacing"));if(e)this.ctx_.font=e;else{var n=this.adapter_.getComputedStyleValue("font-family").split(",")[0],i=this.adapter_.getComputedStyleValue("font-size");this.ctx_.font=i+" "+n}for(var o=0,r=0,s=this.adapter_.getNumberOfOptions();r<s;r++){var a=parseInt(this.adapter_.getComputedStyleValue("padding-right"),10)+parseInt(this.adapter_.getComputedStyleValue("padding-left"),10),u=this.adapter_.getTextForOptionAtIndex(r).trim(),l=this.ctx_.measureText(u).width,c=t*u.length;o=Math.max(o,Math.ceil(l+c+a))}this.adapter_.setStyle("width",o+"px")}},{key:"open_",value:function(){var e=this;this.disableScroll_();var n=t.cssClasses.OPEN,i=this.selectedIndex_<0?0:this.selectedIndex_;this.setMenuStylesForOpenAtIndex_(i),this.adapter_.addClassToLabel(b.LABEL_FLOAT_ABOVE),this.adapter_.addClassToBottomLine(b.BOTTOM_LINE_ACTIVE),this.adapter_.addClass(n),this.animationRequestId_=requestAnimationFrame(function(){e.adapter_.openMenu(i),e.isFocused_=!0})}},{key:"setMenuStylesForOpenAtIndex_",value:function(e){var t=this.adapter_.getWindowInnerHeight(),n=this.adapter_.computeBoundingRect(),i=n.left,o=n.top;this.adapter_.setMenuElAttr("aria-hidden","true"),this.adapter_.setMenuElStyle("display","block");var r=this.adapter_.getMenuElOffsetHeight(),s=this.adapter_.getOffsetTopForOptionAtIndex(e);this.adapter_.setMenuElStyle("display",""),this.adapter_.rmMenuElAttr("aria-hidden");var a=o-s,u=a+r>t;a<0?a=0:u&&(a=Math.max(0,t-r)),this.adapter_.setMenuElStyle("left",i+"px"),this.adapter_.setMenuElStyle("top",a+"px"),this.adapter_.setMenuElStyle("transform-origin","center "+s+"px")}},{key:"close_",value:function(){var e=t.cssClasses.OPEN;this.adapter_.removeClass(e),this.adapter_.removeClassFromBottomLine(b.BOTTOM_LINE_ACTIVE),this.adapter_.focus(),this.enableScroll_()}},{key:"handleDisplayViaKeyboard_",value:function(e){if(2===e.eventPhase){"keydown"===e.type&&("Space"===e.key||32===e.keyCode)&&e.preventDefault();E.some(function(t){var n=t.key,i=t.keyCode,o=t.forType;return e.type===o&&(e.key===n||e.keyCode===i)})&&this.displayHandler_(e)}}},{key:"disableScroll_",value:function(){this.adapter_.addBodyClass(b.SCROLL_LOCK)}},{key:"enableScroll_",value:function(){this.adapter_.removeBodyClass(b.SCROLL_LOCK)}}]),t}(),I={render:function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",{staticClass:"mdc-select mdc-menu-select",class:e.classes,attrs:{role:"listbox"}},[n("div",{ref:"surface",staticClass:"mdc-select__surface",style:e.surfaceStyles,attrs:{tabindex:e.tabIndex}},[n("div",{ref:"label",staticClass:"mdc-select__label",class:e.labelClasses},[e._v(e._s(e.label))]),e._v(" "),n("div",{ref:"selectedContent",staticClass:"mdc-select__selected-text"},[e._v(e._s(e.selectedTextContent))]),e._v(" "),n("div",{ref:"bottomLine",staticClass:"mdc-select__bottom-line",class:e.bottomLineClasses})]),e._v(" "),n("mdc-menu",{ref:"menu",staticClass:"mdc-select__menu",on:{update:e.refreshIndex}},[e._t("default")],2)],1)},staticRenderFns:[],name:"mdc-menu-select",model:{prop:"value",event:"change"},props:{multiple:Boolean,value:[String,Array],disabled:Boolean,label:String},data:function(){return{classes:{},labelClasses:{},bottomLineClasses:{},surfaceStyles:{},tabIndex:0,selectedTextContent:""}},components:{"mdc-menu":g},watch:{disabled:function(e){this.foundation&&this.foundation.setDisabled(e)},value:function(){this.refreshIndex()}},methods:{refreshIndex:function(){if(this.foundation){for(var e=this.$refs.menu.items,t=0;t<e.length;t++){var n=e[t].getAttribute("data-value")||e[t].textContent.trim();if(this.value==n)return this.foundation.setSelectedIndex(t),void this.$set(this.labelClasses,"mdc-select__label--float-above",!0)}this.foundation.setSelectedIndex(-1),this.$set(this.labelClasses,"mdc-select__label--float-above",!1),this.$emit("change",this.foundation.getValue())}}},mounted:function(){var e=this;this.foundation=new C({addClass:function(t){return e.$set(e.classes,t,!0)},removeClass:function(t){return e.$delete(e.classes,t)},addClassToLabel:function(t){return e.$set(e.labelClasses,t,!0)},removeClassFromLabel:function(t){return e.$delete(e.labelClasses,t)},addClassToBottomLine:function(t){return e.$set(e.bottomLineClasses,t,!0)},removeClassFromBottomLine:function(t){return e.$delete(e.bottomLineClasses,t)},setBottomLineAttr:function(t,n){return e.$refs.bottomLine.setAttribute(t,n)},setAttr:function(t,n){return e.$el.setAttribute(t,n)},rmAttr:function(t,n){return e.$el.removeAttribute(t,n)},computeBoundingRect:function(){return e.$refs.surface.getBoundingClientRect()},registerInteractionHandler:function(t,n){return e.$refs.surface.addEventListener(t,n)},deregisterInteractionHandler:function(t,n){return e.$refs.surface.removeEventListener(t,n)},focus:function(){return e.$refs.surface.focus()},makeTabbable:function(){e.tabIndex=0},makeUntabbable:function(){e.tabIndex=-1},getComputedStyleValue:function(t){return window.getComputedStyle(e.$refs.surface).getPropertyValue(t)},setStyle:function(t,n){return e.$set(e.surfaceStyles,t,n)},create2dRenderingContext:function(){return document.createElement("canvas").getContext("2d")},setMenuElStyle:function(t,n){return e.$refs.menu.$el.style[t]=n},setMenuElAttr:function(t,n){return e.$refs.menu.$el.setAttribute(t,n)},rmMenuElAttr:function(t){return e.$refs.menu.$el.removeAttribute(t)},getMenuElOffsetHeight:function(){return e.$refs.menu.$el.offsetHeight},openMenu:function(t){return e.$refs.menu.show({focusIndex:t})},isMenuOpen:function(){return e.$refs.menu.isOpen()},setSelectedTextContent:function(t){e.selectedTextContent=t},getNumberOfOptions:function(){return e.$refs.menu.items.length},getTextForOptionAtIndex:function(t){return e.$refs.menu.items[t].textContent.trim()},getValueForOptionAtIndex:function(t){return e.$refs.menu.items[t].getAttribute("data-value")||e.$refs.menu.items[t].textContent.trim()},setAttrForOptionAtIndex:function(t,n,i){return e.$refs.menu.items[t].setAttribute(n,i)},rmAttrForOptionAtIndex:function(t,n){return e.$refs.menu.items[t].removeAttribute(n)},getOffsetTopForOptionAtIndex:function(t){return e.$refs.menu.items[t].offsetTop},registerMenuInteractionHandler:function(t,n){return e.$refs.menu.$el.addEventListener(t,n)},deregisterMenuInteractionHandler:function(t,n){return e.$refs.menu.$el.removeEventListener(t,n)},notifyChange:function(){e.$emit("change",e.foundation.getValue())},getWindowInnerHeight:function(){return window.innerHeight},addBodyClass:function(e){return document.body.classList.add(e)},removeBodyClass:function(e){return document.body.classList.remove(e)}});var t=this.foundation;t.resize=function(){var n=t.adapter_.getComputedStyleValue("font"),i=parseFloat(t.adapter_.getComputedStyleValue("letter-spacing"));if(n)t.ctx_.font=n;else{var o=t.adapter_.getComputedStyleValue("font-family").split(",")[0],r=t.adapter_.getComputedStyleValue("font-size");t.ctx_.font=r+" "+o}for(var s=0,a=parseInt(t.adapter_.getComputedStyleValue("padding-right"),10)+parseInt(t.adapter_.getComputedStyleValue("padding-left"),10),u=0,l=t.adapter_.getNumberOfOptions();u<l;u++){var c=t.adapter_.getTextForOptionAtIndex(u).trim(),d=t.ctx_.measureText(c).width,f=i*c.length;s=Math.max(s,Math.ceil(d+f+a))}var h=e.label,m=t.ctx_.measureText(h).width,_=i*h.length;s=Math.max(s,Math.ceil(m+_+a)),t.adapter_.setStyle("width",s+"px")},this.foundation.init(),this.foundation.setDisabled(this.disabled),this.refreshIndex(),this.value!==this.foundation.getValue()&&this.$emit("change",this.foundation.getValue())},beforeDestroy:function(){var e=this.foundation;this.foundation=null,e.destroy()}},O={render:function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("select",{directives:[{name:"model",rawName:"v-model",value:e.selected,expression:"selected"}],ref:"root",staticClass:"mdc-select mdc-multi-select mdc-list",style:e.styles,attrs:{multiple:e.multiple,disabled:e.disabled},on:{change:[function(t){var n=Array.prototype.filter.call(t.target.options,function(e){return e.selected}).map(function(e){return"_value"in e?e._value:e.value});e.selected=t.target.multiple?n:n[0]},e.onChange]}},[e.label?n("optgroup",{ref:"optgroup",staticClass:"mdc-list-group",attrs:{label:e.label}},[e._t("default")],2):e._t("default")],2)},staticRenderFns:[],name:"mdc-multi-select",model:{prop:"value",event:"change"},props:{multiple:Boolean,value:[String,Array],disabled:Boolean,label:String,"max-size":[String,Number]},data:function(){return{selected:this.value,size:void 0,count:void 0}},computed:{styles:function(){var e=this.count>this.size,t={height:48*this.size+(e?0:16)+"px","overflow-y":e?"scroll":"hidden"};return e||(t["background-image"]="unset"),t}},methods:{onChange:function(){this.$emit("change",this.selected)}},mounted:function(){var e=this,t=function(){var t=e.$refs.root.querySelectorAll("option, optgroup").length;e.count=t;var n=Number(e.maxSize);e.label&&(n+=1),e.size=Math.min(t,n)};this.slotObserver=new MutationObserver(function(){return t()}),this.slotObserver.observe(this.$el,{childList:!0,subtree:!0}),t()},beforeDestroy:function(){this.slotObserver.disconnect()}},A=new(function(){function e(){n(this,e)}return i(e,[{key:"mobile",get:function(){return this._mobile||(this._mobile=window.matchMedia("(max-width: 600px) and (pointer: coarse)"))}}]),e}()),k={render:function(){var e=this,t=e.$createElement;return(e._self._c||t)(e.type,{tag:"component",attrs:{multiple:e.multiple,"max-size":e.multiple?e.maxSize:void 0,disabled:e.disabled,label:e.label,value:e.value,name:e.name},on:{change:e.onChange}},[e._t("default")],2)},staticRenderFns:[],name:"mdc-select",mixins:[u],model:{prop:"value",event:"change"},props:{multiple:Boolean,value:[String,Array],disabled:Boolean,label:String,maxSize:{type:[String,Number],default:4},name:String,native:Boolean},provide:function(){return{mdcSelect:this}},components:{"mdc-native-select":l,"mdc-menu-select":I,"mdc-multi-select":O},data:function(){return{mobile:!window||A.mobile.matches}},computed:{type:function(){return this.multiple?"mdc-multi-select":this.menu?"mdc-menu-select":this.isNative?"mdc-native-select":"mdc-menu-select"},isNative:function(){return this.native||this.multiple||this.mobile}},methods:{onChange:function(e){this.$emit("change",e)},refreshMedia:function(){this.mobile=A.mobile.matches}},beforeMount:function(){A.mobile.addListener(this.refreshMedia),this.refreshMedia()},beforeDestroy:function(){A.mobile.removeListener(this.refreshMedia)}},x={render:function(){var e=this.$createElement,t=this._self._c||e;return this.hasValue?t("option",{staticClass:"mdc-option mdc-native-option",attrs:{disabled:this.disabled},domProps:{value:this.value}},[this._t("default")],2):t("option",{staticClass:"mdc-option mdc-native-option",attrs:{disabled:this.disabled}},[this._t("default")],2)},staticRenderFns:[],name:"mdc-native-option",props:{value:String,disabled:Boolean},computed:{hasValue:function(){return!(void 0===this.value)}}},M={render:function(){var e=this.$createElement;return(this._self._c||e)("li",{staticClass:"mdc-option mdc-menu-option mdc-list-item",attrs:{role:"option",tabindex:this.disabled?-1:0,"aria-disabled":this.disabled,"data-value":this.value}},[this._t("default")],2)},staticRenderFns:[],name:"mdc-menu-option",props:{value:String,disabled:Boolean}},L={render:function(){var e=this.$createElement,t=this._self._c||e;return this.hasValue?t("option",{staticClass:"mdc-option mdc-multi-option mdc-list-item",attrs:{disabled:this.disabled},domProps:{value:this.value}},[this._t("default")],2):t("option",{staticClass:"mdc-option mdc-multi-option mdc-list-item",attrs:{disabled:this.disabled}},[this._t("default")],2)},staticRenderFns:[],name:"mdc-multi-option",props:{value:String,disabled:Boolean},computed:{hasValue:function(){return!(void 0===this.value)}}},S=function(e){return{version:"0.9.2",install:function(t){for(var n in e){var i=e[n];t.component(i.name,i)}},components:e}}({mdcSelect:k,mdcOption:{render:function(){var e=this.$createElement;return(this._self._c||e)(this.type,{tag:"component",attrs:{disabled:this.disabled,value:this.value}},[this._t("default")],2)},staticRenderFns:[],name:"mdc-option",props:{value:String,disabled:Boolean},inject:["mdcSelect"],components:{"mdc-native-option":x,"mdc-multi-option":L,"mdc-menu-option":M},computed:{isNative:function(){return this.mdcSelect.isNative},multiple:function(){return this.mdcSelect.multiple},type:function(){return this.multiple?"mdc-multi-option":this.isNative?"mdc-native-option":"mdc-menu-option"}}}});return function(e){var t=null;"undefined"!=typeof window?t=window.Vue:"undefined"!=typeof global&&(t=global.Vue),t&&t.use(e)}(S),S});
//# sourceMappingURL=select.min.js.map
